"use strict";
cc._RF.push(module, '3724ceFPBxItZWFlXSAAmgh', 'ray-cast-reflection');
// ray-cast-reflection.js

'use strict';

cc.Class({
    extends: cc.Component,

    properties: {
        radius: 50

    },

    // use this for initialization
    onLoad: function onLoad() {
        cc.director.getPhysicsManager().enabled = true;

        cc.director.getPhysicsManager().debugDrawFlags = cc.PhysicsManager.DrawBits.e_aabbBit | cc.PhysicsManager.DrawBits.e_pairBit | cc.PhysicsManager.DrawBits.e_centerOfMassBit | cc.PhysicsManager.DrawBits.e_jointBit | cc.PhysicsManager.DrawBits.e_shapeBit;

        // thiss stops debug drawing - 0 disable, 1 enable drawing
        cc.director.getPhysicsManager().debugDrawFlags = 1;

        //  cc.director.getPhysicsManager().attachDebugDrawToCamera (cam);

        this.ctx = this.getComponent(cc.Graphics);
        this.angle = 0;
        this.center = cc.v2(cc.winSize.width / 2, cc.winSize.height / 2);

        //   this.angle += Math.PI / 20 * 4;
    },

    // called every frame, uncomment this function to activate update callback
    update: function update(dt) {
        this.angle += Math.PI / 20 * dt;

        // this.angle += Math.PI / 20 * 1;

        this.ctx.clear();

        var p1 = this.center;
        this.drawCircle(p1);
        cc.log('p1 center: ' + p1);
        var p2 = cc.v2(Math.cos(this.angle), Math.sin(this.angle)).mulSelf(this.radius).addSelf(this.center);

        this.remainLength = this.radius;

        this.rayCast(p1, p2);
    },

    drawCircle: function drawCircle(p) {
        this.ctx.circle(p.x, p.y, 5);
        this.ctx.fill();
    },

    rayCast: function rayCast(p1, p2) {
        var manager = cc.director.getPhysicsManager();

        var results = manager.rayCast(p1, p2)[0];

        if (results) {
            p2 = results.point;
            this.ctx.circle(p2.x, p2.y, 5);
            this.ctx.fill();
        }

        this.ctx.moveTo(p1.x, p1.y);
        this.ctx.lineTo(p2.x, p2.y);
        this.ctx.stroke();

        if (!results) return;

        this.remainLength = this.remainLength - p2.sub(p1).mag();
        if (this.remainLength < 1) return;

        var inVector = p2.sub(p1);
        p1 = p2;
        p2 = results.normal.mul(this.remainLength).add(p1);

        //  this.rayCast(p1, p2);

        this.rayCastReflect(results.point, inVector, results.normal);
    },

    rayCastReflect: function rayCastReflect(intersectionPoint, inVector, NVector) {

        var prodVec = cc.pDot(inVector, NVector);

        //calculate the reflection vector
        var retVec = inVector.sub(cc.pMult(cc.pCompMult(prodVec, NVector), 2));

        var finalpos = cc.Vec2();

        //update the vector position 
        finalpos = retVec.add(intersectionPoint);

        cc.log('final reflect pos: ' + finalpos);

        this.drawCircle(finalpos);
        this.ctx.moveTo(intersectionPoint.x, intersectionPoint.y);
        this.ctx.lineTo(finalpos.x, finalpos.y);
        this.ctx.stroke();
    }

});

cc._RF.pop();